Index: src/uk/me/parabola/imgfmt/app/lbl/Country.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/lbl/Country.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/lbl/Country.java	(working copy)
@@ -26,7 +26,7 @@
  */
 public class Country {
 	// The country number.  This is not recorded in the file
-	private char index;
+	private int index;
 	private Label label;
 
 	public Country(int index) {
@@ -34,10 +34,10 @@
 	}
 
 	void write(ImgFileWriter writer) {
-		writer.put3(label.getOffset());
+		writer.put3u(label.getOffset());
 	}
 
-	public char getIndex() {
+	public int getIndex() {
 		return index;
 	}
 
@@ -50,6 +50,6 @@
 	}
 
 	public void setIndex(int index) {
-		this.index = (char) index;
+		this.index = index;
 	}
 }
Index: src/uk/me/parabola/imgfmt/app/lbl/ExitFacility.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/lbl/ExitFacility.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/lbl/ExitFacility.java	(working copy)
@@ -51,9 +51,10 @@
 		word |= type << 24;	 // 24:27 = 4 bit type
 		// 28 = unknown
 		word |= direction << 29; // 29:31 = 3 bit direction
-		writer.putChar((char)word);
-		writer.putChar((char)(word >> 16));
-		writer.put((byte)facilities);
+//		writer.put2u(word && 0xffff);
+//		writer.put2u(word >> 16);
+		writer.put4(word);
+		writer.put1u(facilities);
 	}
 
 	public int getIndex() {
Index: src/uk/me/parabola/imgfmt/app/lbl/Highway.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/lbl/Highway.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/lbl/Highway.java	(working copy)
@@ -33,9 +33,9 @@
 
 	class ExitPoint implements Comparable<ExitPoint> {
 		final String name;
-		final byte index;
+		final int index;
 		final Subdivision div;
-		public ExitPoint(String name, byte index, Subdivision div) {
+		public ExitPoint(String name, int index, Subdivision div) {
 			this.name = name;
 			this.index = index;
 			this.div = div;
@@ -63,19 +63,19 @@
 
 	void write(ImgFileWriter writer, boolean extraData) {
 		if(extraData) {
-			writer.put((byte)0);
-			writer.putChar(region == null? 0 : region.getIndex());
+			writer.put1u(0);
+			writer.put2u(region == null? 0 : region.getIndex());
 			Collections.sort(exits);
 			for(ExitPoint ep : exits) {
-			    writer.put(ep.index);
-			    writer.putChar((char)ep.div.getNumber());
+				writer.put1u(ep.index);
+				writer.put2u(ep.div.getNumber());
 			}
 		}
 		else {
 			assert extraDataOffset != 0;
-			writer.put3(label.getOffset());
-			writer.putChar((char)extraDataOffset);
-			writer.put((byte)0); // unknown (setting any of 0x3f stops exits being found)
+			writer.put3u(label.getOffset());
+			writer.put2u(extraDataOffset);
+			writer.put1u(0); // unknown (setting any of 0x3f stops exits being found)
 		}
 	}
 
@@ -96,6 +96,6 @@
 	}
 
 	public void addExitPoint(String name, int index, Subdivision div) {
-		exits.add(new ExitPoint(name, (byte)index, div));
+		exits.add(new ExitPoint(name, index, div));
 	}
 }
Index: src/uk/me/parabola/imgfmt/app/lbl/LBLFile.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/lbl/LBLFile.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/lbl/LBLFile.java	(working copy)
@@ -71,7 +71,7 @@
 		position(LBLHeader.HEADER_LEN + lblHeader.getSortDescriptionLength());
 
 		// The zero offset is for no label.
-		getWriter().put((byte) 0);
+		getWriter().put1u(0);
 		alignForNext();
 
 		places.init(this, lblHeader.getPlaceHeader());
@@ -91,7 +91,7 @@
 
 		// Text can be put between the header and the body of the file.
 		writer.put(Utils.toBytes(sort.getDescription()));
-		writer.put((byte) 0);
+		writer.put1u(0);
 		assert writer.position() == LBLHeader.HEADER_LEN + lblHeader.getSortDescriptionLength();
 	}
 
@@ -157,7 +157,7 @@
 	private void alignForNext() {
 		// Align ready for next label
 		while ((getCurrentLabelOffset() & ((1 << offsetMultiplier) - 1)) != 0)
-			getWriter().put((byte) 0);
+			getWriter().put1u(0);
 	}
 
 	private int getNextLabelOffset() {
Index: src/uk/me/parabola/imgfmt/app/lbl/LBLFileReader.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/lbl/LBLFileReader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/lbl/LBLFileReader.java	(working copy)
@@ -139,7 +139,7 @@
 		reader.position(start);
 		int index = 1;
 		while (reader.position() < end) {
-			int offset = reader.getu3();
+			int offset = reader.get3u();
 			Label label = fetchLabel(offset);
 
 			if (label != null) {
@@ -167,8 +167,8 @@
 		reader.position(start);
 		int index = 1;
 		while (reader.position() < end) {
-			int country = reader.getChar();
-			int offset = reader.getu3();
+			int country = reader.get2u();
+			int offset = reader.get3u();
 			Label label = fetchLabel(offset);
 			if (label != null) {
 				Region region = new Region(countries.get(country));
@@ -200,8 +200,8 @@
 		while (reader.position() < end) {
 			// First is either a label offset or a point/subdiv combo, we
 			// don't know until we have read further
-			int label = reader.getu3();
-			int info = reader.getChar();
+			int label = reader.get3u();
+			int info = reader.get2u();
 
 			City city;
 			if ((info & 0x4000) == 0) {
@@ -221,7 +221,7 @@
 				// Has subdiv/point index
 				int pointIndex = label & 0xff;
 				int subdiv = (label >> 8) & 0xffff;
-				city.setPointIndex((byte) pointIndex);
+				city.setPointIndex(pointIndex);
 				city.setSubdivision(Subdivision.createEmptySubdivision(subdiv));
 			}
 			cities.add(city);
@@ -311,7 +311,7 @@
 
 		int zipIndex = 1;
 		while (reader.position() < end) {
-			int lblOffset = reader.get3();
+			int lblOffset = reader.get3u();
 			
 			Zip zip = new Zip();
 			zip.setLabel(fetchLabel(lblOffset));
@@ -344,7 +344,7 @@
 
 		while (reader.position() < end) {
 			int poiOffset = position() - start;
-			int val = reader.getu3();
+			int val = reader.get3u();
 			int labelOffset = val & 0x3fffff;
 
 
@@ -365,7 +365,7 @@
 			boolean hasTides;
 
 			if (override) {
-				flags = reader.get();
+				flags = reader.get1u();
 
 				hasStreetNum = (flags & localMask.streetNumMask) != 0;
 				hasStreet = (flags & localMask.streetMask) != 0;
@@ -390,7 +390,7 @@
 				byte b = reader.get();
 				if ((b & 0x80) == 0) {
 					int mpoffset = (b << 16) & 0xff0000;
-					mpoffset |= reader.getChar() & 0xffff;
+					mpoffset |= reader.get2u();
 
 					poi.setComplexStreetNumber(fetchLabel(mpoffset));
 				} else {
@@ -399,18 +399,18 @@
 			}
 
 			if (hasStreet) {
-				int streetNameOffset = reader.getu3();// label for street
+				int streetNameOffset = reader.get3u();// label for street
 				Label label = fetchLabel(streetNameOffset);
 				poi.setStreetName(label);
 			}
 
 			if (hasCity) {
-				int cityIndex = reader.getUint(Utils.numberToPointerSize(placeHeader.getNumCities()));
+				int cityIndex = reader.getNu(Utils.numberToPointerSize(placeHeader.getNumCities()));
 				poi.setCity(cities.get(cityIndex-1));
 			}
 
 			if (hasZip) {
-				int zipIndex = reader.getUint(Utils.numberToPointerSize(placeHeader.getNumZips()));
+				int zipIndex = reader.getNu(Utils.numberToPointerSize(placeHeader.getNumZips()));
 				poi.setZip(zips.get(zipIndex-1));
 			}
 			
@@ -419,7 +419,7 @@
 				if ((b & 0x80) == 0) {
 					// Yes this is a bit strange it is a byte followed by a char
 					int mpoffset = (b << 16) & 0xff0000;
-					mpoffset |= reader.getChar() & 0xffff;
+					mpoffset |= reader.get2u();
 
 					poi.setComplexPhoneNumber(fetchLabel(mpoffset));
 				} else {
@@ -428,14 +428,14 @@
 			}
 
 			if (hasHighwayExit) {
-				int lblinfo = reader.getu3();
+				int lblinfo = reader.get3u();
 				int highwayLabelOffset = lblinfo & 0x3FFFF;
 				boolean indexed = (lblinfo & 0x800000) != 0;
 				boolean overnightParking = (lblinfo & 0x400000) != 0;
 
-				int highwayIndex = reader.getUint(Utils.numberToPointerSize(placeHeader.getNumHighways()));
+				int highwayIndex = reader.getNu(Utils.numberToPointerSize(placeHeader.getNumHighways()));
 				if (indexed) {
-					int eidx = reader.getUint(Utils.numberToPointerSize(placeHeader.getNumExits()));
+					int eidx = reader.getNu(Utils.numberToPointerSize(placeHeader.getNumExits()));
 				}
 			}
 
@@ -457,7 +457,7 @@
 	private PoiMasks makeLocalMask(PlacesHeader placeHeader) {
 		int globalPoi = placeHeader.getPOIGlobalFlags();
 
-		char mask= 0x1;
+		int mask= 0x1;
 
 		boolean hasStreetNum = (globalPoi & POIRecord.HAS_STREET_NUM) != 0;
 		boolean hasStreet = (globalPoi & POIRecord.HAS_STREET) != 0;
@@ -524,13 +524,13 @@
 	}
 
 	private class PoiMasks {
-		private char streetNumMask;
-		private char streetMask;
-		private char cityMask;
-		private char zipMask;
-		private char phoneMask;
-		private char highwayExitMask;
-		private char tidesMask;
+		private int streetNumMask;
+		private int streetMask;
+		private int cityMask;
+		private int zipMask;
+		private int phoneMask;
+		private int highwayExitMask;
+		private int tidesMask;
 	}
 
 	public int getEncodingType() {
Index: src/uk/me/parabola/imgfmt/app/lbl/LBLHeader.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/lbl/LBLHeader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/lbl/LBLHeader.java	(working copy)
@@ -68,8 +68,8 @@
 	 * @param reader The header is read from here.
 	 */
 	protected void readFileHeader(ImgFileReader reader) {
-		labelStart = reader.getInt();
-		labelSize = reader.getInt();
+		labelStart = reader.get4();
+		labelSize = reader.get4();
 		offsetMultiplier = 1 << reader.get();
 		encodingType = reader.get();
 
@@ -76,11 +76,11 @@
 		// Read the places part of the header.
 		placeHeader.readFileHeader(reader);
 
-		int codepage = reader.getChar();
-		int id1 = reader.getChar();
-		int id2 = reader.getChar();
-		int descOff = reader.getInt();
-		int descLen = reader.getInt();
+		int codepage = reader.get2u();
+		int id1 = reader.get2u();
+		int id2 = reader.get2u();
+		int descOff = reader.get4();
+		int descLen = reader.get4();
 
 		reader.position(descOff);
 		byte[] bytes = reader.get(descLen);
@@ -109,32 +109,32 @@
 	 */
 	protected void writeFileHeader(ImgFileWriter writer) {
 		// LBL1 section, these are regular labels
-		writer.putInt(HEADER_LEN + sortDescriptionLength);
-		writer.putInt(getLabelSize());
+		writer.put4(HEADER_LEN + sortDescriptionLength);
+		writer.put4(getLabelSize());
 
-		writer.put((byte) offsetMultiplier);
-		writer.put((byte) encodingType);
+		writer.put1u(offsetMultiplier);
+		writer.put1u(encodingType);
 
 		placeHeader.writeFileHeader(writer);
 
-		writer.putChar((char) getCodePage());
+		writer.put2u(getCodePage());
 
 		// Identifying the sort
-		char id1 = (char) sort.getId1();
-		writer.putChar(id1);
+		int id1 = sort.getId1();
+		writer.put2u(id1);
 		
-		char id2 = (char) sort.getId2();
+		int id2 = sort.getId2();
 		if (id1 != 0 && id2 != 0)
 			id2 |= 0x8000;
-		writer.putChar(id2);
+		writer.put2u(id2);
 
-		writer.putInt(HEADER_LEN);
-		writer.putInt(sortDescriptionLength);
+		writer.put4(HEADER_LEN);
+		writer.put4(sortDescriptionLength);
 
-		writer.putInt(placeHeader.getLastPos());
-		writer.putInt(0);
-		writer.putChar(UNK3_REC_LEN);
-		writer.putChar((char) 0);
+		writer.put4(placeHeader.getLastPos());
+		writer.put4(0);
+		writer.put2u(UNK3_REC_LEN);
+		writer.put2u(0);
 	}
 
 	protected int getEncodingType() {
Index: src/uk/me/parabola/imgfmt/app/lbl/POIIndex.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/lbl/POIIndex.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/lbl/POIIndex.java	(working copy)
@@ -27,11 +27,11 @@
 public class POIIndex {
 
 	private final String name;
-	private final byte poiIndex;
+	private final int poiIndex;
 	private final Subdivision group;
-	private final byte subType;
+	private final int subType;
 
-	public POIIndex(String name, byte poiIndex, Subdivision group, byte subType) {
+	public POIIndex(String name, int poiIndex, Subdivision group, int subType) {
 		this.name = name;
 		this.poiIndex = poiIndex;
 		this.group = group;
@@ -39,9 +39,9 @@
 	}
 
 	void write(ImgFileWriter writer) {
-		writer.put(poiIndex);
-		writer.putChar((char)group.getNumber());
-		writer.put(subType);
+		writer.put1u(poiIndex);
+		writer.put2u(group.getNumber());
+		writer.put1u(subType);
 	}
 
 	public String getName() {
Index: src/uk/me/parabola/imgfmt/app/lbl/POIRecord.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/lbl/POIRecord.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/lbl/POIRecord.java	(working copy)
@@ -28,13 +28,13 @@
  */
 public class POIRecord {
 
-	static final byte HAS_STREET_NUM = 0x01;
-	static final byte HAS_STREET     = 0x02;
-	static final byte HAS_CITY       = 0x04;
-	static final byte HAS_ZIP        = 0x08;
-	static final byte HAS_PHONE      = 0x10;
-	static final byte HAS_EXIT       = 0x20;
-	static final byte HAS_TIDE_PREDICTION = 0x40;
+	static final int HAS_STREET_NUM = 0x01;
+	static final int HAS_STREET     = 0x02;
+	static final int HAS_CITY       = 0x04;
+	static final int HAS_ZIP        = 0x08;
+	static final int HAS_PHONE      = 0x10;
+	static final int HAS_EXIT       = 0x20;
+	static final int HAS_TIDE_PREDICTION = 0x40;
 
 	/* Not used yet
 	private static final AddrAbbr ABBR_HASH = new AddrAbbr(' ', "#");
@@ -105,45 +105,42 @@
 		this.exit = exit;
 	}
 
-	void write(ImgFileWriter writer, byte POIGlobalFlags, int realofs,
+	void write(ImgFileWriter writer, int POIGlobalFlags, int realofs,
 		   long numCities, long numZips, long numHighways, long numExitFacilities) {
 		assert offset == realofs : "offset = " + offset + " realofs = " + realofs;
 		int ptr = poiName.getOffset();
 		if (POIGlobalFlags != getPOIFlags())
 			ptr |= 0x800000;
-		writer.put3(ptr);
+		writer.put3u(ptr);
 
 		if (POIGlobalFlags != getPOIFlags())
-			writer.put(getWrittenPOIFlags(POIGlobalFlags));
+			writer.put1u(getWrittenPOIFlags(POIGlobalFlags));
 
 		if (streetNumberName != null)
 		{
 			int labOff = streetNumberName.getOffset();
-			writer.put((byte)((labOff & 0x7F0000) >> 16));
-			writer.putChar((char)(labOff & 0xFFFF));
+			// !!! seems to write as hybrid endian
+			writer.put1u(labOff >> 16);
+			writer.put2u(labOff & 0xFFFF);
 		}
 		else if (simpleStreetNumber.isUsed())
 			simpleStreetNumber.write(writer);
 
 		if (streetName != null)
-			writer.put3(streetName.getOffset());
+			writer.put3u(streetName.getOffset());
 
 		if (city != null)
-		{
-			char cityIndex = (char) city.getIndex();
-			writer.putN(Utils.numberToPointerSize((int)numCities), cityIndex);
-		}
+			writer.putNu(Utils.numberToPointerSize((int)numCities), city.getIndex());
 
-		if (zip != null) {
-			char zipIndex = (char) zip.getIndex();
-			writer.putN(Utils.numberToPointerSize((int)numZips), zipIndex);
-		}
+		if (zip != null)
+			writer.putNu(Utils.numberToPointerSize((int)numZips), zip.getIndex());
 
 		if (complexPhoneNumber != null)
 		{
 			int labOff = complexPhoneNumber.getOffset();
-			writer.put((byte)((labOff & 0x7F0000) >> 16));
-			writer.putChar((char)(labOff & 0xFFFF));
+			// !!! seems to write as hybrid endian
+			writer.put1u(labOff >> 16);
+			writer.put2u(labOff & 0xFFFF);
 		}
 		else if (simplePhoneNumber.isUsed())
 			simplePhoneNumber.write(writer);
@@ -163,20 +160,20 @@
 				ef = facilites.get(0);
 			if(ef != null)
 				val |= 0x800000; // exit facilities defined
-			writer.put3(val);
+			writer.put3u(val);
 
-			char highwayIndex = (char)exit.getHighway().getIndex();
-			writer.putN(Utils.numberToPointerSize((int)numHighways), highwayIndex);
+			int highwayIndex = exit.getHighway().getIndex();
+			writer.putNu(Utils.numberToPointerSize((int)numHighways), highwayIndex);
 
 			if(ef != null) {
-				char exitFacilityIndex = (char)ef.getIndex();
-				writer.putN(Utils.numberToPointerSize((int)numExitFacilities), exitFacilityIndex);
+				int exitFacilityIndex = ef.getIndex();
+				writer.putNu(Utils.numberToPointerSize((int)numExitFacilities), exitFacilityIndex);
 			}
 		}
 	}
 
-	byte getPOIFlags() {
-		byte b = 0;
+	int getPOIFlags() {
+		int b = 0;
 		if (streetName != null)
 			b |= HAS_STREET;
 		if (simpleStreetNumber.isUsed() || streetNumberName != null)
@@ -192,7 +189,7 @@
 		return b;
 	}
 	
-	byte getWrittenPOIFlags(byte POIGlobalFlags) 
+	int getWrittenPOIFlags(int POIGlobalFlags)
 	{
 		int flag = 0;
 		int j = 0;
@@ -218,15 +215,15 @@
 
 		flag |= 0x80; // gpsmapedit asserts for this bit set
 	    
-		return (byte) flag;
+		return flag;
 	}
 
 	/**
 	 * Sets the start offset of this POIRecord
 	 *
-	 * \return Number of bytes needed by this entry
+	 * @return Number of bytes needed by this entry
 	 */
-	int calcOffset(int ofs, byte POIGlobalFlags, long numCities, long numZips, long numHighways, long numExitFacilities) {
+	int calcOffset(int ofs, int POIGlobalFlags, long numCities, long numZips, long numHighways, long numExitFacilities) {
 		offset = ofs;
 		int size = 3;
 		if (exit != null) {
@@ -340,8 +337,9 @@
 
 		public void write(ImgFileWriter writer)
 		{
-			for(int i = 0; i < encodedSize; i++)
-				writer.put(encodedNumber[i]);
+//			for(int i = 0; i < encodedSize; i++)
+//				writer.put1u(encodedNumber[i]);
+			writer.put(encodedNumber, 0, encodedSize);
 		}
 
 		public boolean isUsed()
Index: src/uk/me/parabola/imgfmt/app/lbl/PlacesFile.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/lbl/PlacesFile.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/lbl/PlacesFile.java	(working copy)
@@ -108,7 +108,7 @@
 		placeHeader.endPOIIndex(writer.position());
 
 		int poistart = writer.position();
-		byte poiglobalflags = placeHeader.getPOIGlobalFlags();
+		int poiglobalflags = placeHeader.getPOIGlobalFlags();
 		for (POIRecord p : pois)
 			p.write(writer, poiglobalflags,
 				writer.position() - poistart, cityList.size(), postalCodes.size(), highways.size(), exitFacilities.size());
@@ -117,8 +117,8 @@
 		int numPoiIndexEntries = 0;
 		for (int i = 0; i < 256; ++i) {
 			if(poiIndex[i] != null) {
-				writer.put((byte)i);
-				writer.put3(numPoiIndexEntries + 1);
+				writer.put1u(i);
+				writer.put3u(numPoiIndexEntries + 1);
 				numPoiIndexEntries += poiIndex[i].size();
 			}
 		}
@@ -305,7 +305,7 @@
 		if (t < MIN_INDEXED_POI_TYPE || t > MAX_INDEXED_POI_TYPE) 
 			return;
 		
-		POIIndex pi = new POIIndex(name, (byte)index, group, (byte)type);
+		POIIndex pi = new POIIndex(name, index, group, type);
 		if(poiIndex[t] == null)
 			poiIndex[t] = new ArrayList<POIIndex>();
 		poiIndex[t].add(pi);
@@ -319,7 +319,7 @@
 
 		poisClosed = true;
 
-		byte poiFlags = 0;
+		int poiFlags = 0;
 		for (POIRecord p : pois) {
 			poiFlags |= p.getPOIFlags();
 		}
Index: src/uk/me/parabola/imgfmt/app/lbl/PlacesHeader.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/lbl/PlacesHeader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/lbl/PlacesHeader.java	(working copy)
@@ -49,40 +49,40 @@
 	private final Section highway = new Section(zip, HIGHWAY_REC_LEN);
 	private final Section exitFacility = new Section(highway, EXIT_REC_LEN);
 	private final Section highwayData = new Section(exitFacility, HIGHWAYDATA_REC_LEN);
-	private byte POIGlobalFlags ;
+	private int POIGlobalFlags ;
 
-	void setPOIGlobalFlags(byte flags) {
+	void setPOIGlobalFlags(int flags) {
 		this.POIGlobalFlags = flags;
 	}
 
-	byte getPOIGlobalFlags() {
+	int getPOIGlobalFlags() {
 		return POIGlobalFlags;
 	}
 
 	void writeFileHeader(ImgFileWriter writer) {
-		writer.putInt(country.getPosition());
-		writer.putInt(country.getSize());
-		writer.putChar(country.getItemSize());
-		writer.putInt(0);
+		writer.put4(country.getPosition());
+		writer.put4(country.getSize());
+		writer.put2u(country.getItemSize());
+		writer.put4(0);
 
-		writer.putInt(region.getPosition());
-		writer.putInt(region.getSize());
-		writer.putChar(region.getItemSize());
-		writer.putInt(0);
+		writer.put4(region.getPosition());
+		writer.put4(region.getSize());
+		writer.put2u(region.getItemSize());
+		writer.put4(0);
 
-		writer.putInt(city.getPosition());
-		writer.putInt(city.getSize());
-		writer.putChar(city.getItemSize());
-		writer.putInt(0);
+		writer.put4(city.getPosition());
+		writer.put4(city.getSize());
+		writer.put2u(city.getItemSize());
+		writer.put4(0);
 
-		writer.putInt(poiIndex.getPosition());
-		writer.putInt(poiIndex.getSize());
-		writer.putChar(poiIndex.getItemSize());
-		writer.putInt(0);
+		writer.put4(poiIndex.getPosition());
+		writer.put4(poiIndex.getSize());
+		writer.put2u(poiIndex.getItemSize());
+		writer.put4(0);
 
-		writer.putInt(poiProperties.getPosition());
-		writer.putInt(poiProperties.getSize());
-		writer.put((byte) 0); // offset multiplier
+		writer.put4(poiProperties.getPosition());
+		writer.put4(poiProperties.getSize());
+		writer.put1u(0); // offset multiplier
 
 		// mb 5/9/2009 - discovered that Garmin maps can contain more
 		// than 8 bits of POI global flags - have seen the 9th bit set
@@ -91,34 +91,34 @@
 		// of further bytes to read << 1) - therefore, this group
 		// should probably be: 16 bits of POI global flags followed by
 		// 16 zero bits rather than 8 bits of flags and 24 zero bits
-		writer.put(POIGlobalFlags); // properties global mask
-		writer.putChar((char) 0);
-		writer.put((byte) 0);
+		writer.put1u(POIGlobalFlags); // properties global mask
+		writer.put2u(0);
+		writer.put1u(0);
 
-		writer.putInt(poiTypeIndex.getPosition());
-		writer.putInt(poiTypeIndex.getSize());
-		writer.putChar(poiTypeIndex.getItemSize());
-		writer.putInt(0);
+		writer.put4(poiTypeIndex.getPosition());
+		writer.put4(poiTypeIndex.getSize());
+		writer.put2u(poiTypeIndex.getItemSize());
+		writer.put4(0);
 
-		writer.putInt(zip.getPosition());
-		writer.putInt(zip.getSize());
-		writer.putChar(zip.getItemSize());
-		writer.putInt(0);
+		writer.put4(zip.getPosition());
+		writer.put4(zip.getSize());
+		writer.put2u(zip.getItemSize());
+		writer.put4(0);
 
-		writer.putInt(highway.getPosition());
-		writer.putInt(highway.getSize());
-		writer.putChar(highway.getItemSize());
-		writer.putInt(0);
+		writer.put4(highway.getPosition());
+		writer.put4(highway.getSize());
+		writer.put2u(highway.getItemSize());
+		writer.put4(0);
 
-		writer.putInt(exitFacility.getPosition());
-		writer.putInt(exitFacility.getSize());
-		writer.putChar(exitFacility.getItemSize());
-		writer.putInt(0);
+		writer.put4(exitFacility.getPosition());
+		writer.put4(exitFacility.getSize());
+		writer.put2u(exitFacility.getItemSize());
+		writer.put4(0);
 
-		writer.putInt(highwayData.getPosition());
-		writer.putInt(highwayData.getSize());
-		writer.putChar(highwayData.getItemSize());
-		writer.putInt(0);
+		writer.put4(highwayData.getPosition());
+		writer.put4(highwayData.getSize());
+		writer.put2u(highwayData.getItemSize());
+		writer.put4(0);
 	}
 
 	void readFileHeader(ImgFileReader reader) {
@@ -125,38 +125,38 @@
 		reader.position(0x1f);
 
 		country.readSectionInfo(reader, true);
-		reader.getInt();
+		reader.get4();
 
 		region.readSectionInfo(reader, true);
-		reader.getInt();
+		reader.get4();
 
 		city.readSectionInfo(reader, true);
-		reader.getInt();
+		reader.get4();
 
 		poiIndex.readSectionInfo(reader, true);
-		reader.getInt();
+		reader.get4();
 
 		poiProperties.readSectionInfo(reader, false);
 		reader.get(); // offset multiplier
 
-		POIGlobalFlags = reader.get();
-		reader.getChar();
+		POIGlobalFlags = reader.get1u();
+		reader.get2u();
 		reader.get();
 
 		poiTypeIndex.readSectionInfo(reader, true);
-		reader.getInt();
+		reader.get4();
 
 		zip.readSectionInfo(reader, true);
-		reader.getInt();
+		reader.get4();
 
 		highway.readSectionInfo(reader, true);
-		reader.getInt();
+		reader.get4();
 
 		exitFacility.readSectionInfo(reader, true);
-		reader.getInt();
+		reader.get4();
 
 		highwayData.readSectionInfo(reader, true);
-		reader.getInt();
+		reader.get4();
 	}
 
 	int getLastPos() {
Index: src/uk/me/parabola/imgfmt/app/lbl/Region.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/lbl/Region.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/lbl/Region.java	(working copy)
@@ -25,7 +25,7 @@
  * @author Steve Ratcliffe
  */
 public class Region {
-	private char index;
+	private int index;
 
 	private final Country country;
 	private Label label;
@@ -35,11 +35,11 @@
 	}
 
 	public void write(ImgFileWriter writer) {
-		writer.putChar(country.getIndex());
-		writer.put3(label.getOffset());
+		writer.put2u(country.getIndex());
+		writer.put3u(label.getOffset());
 	}
 
-	public char getIndex() {
+	public int getIndex() {
 		assert index > 0 : "Index not yet set";
 		return index;
 	}
@@ -49,7 +49,7 @@
 	}
 
 	public void setIndex(int index) {
-		this.index = (char)index;
+		this.index = index;
 	}
 
 	public void setLabel(Label label) {
Index: src/uk/me/parabola/imgfmt/app/lbl/Zip.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/lbl/Zip.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/lbl/Zip.java	(working copy)
@@ -31,7 +31,7 @@
 	private Label label;
 
 	public void write(ImgFileWriter writer) {
-		writer.put3(label.getOffset());
+		writer.put3u(label.getOffset());
 	}
 
 	public Label getLabel() {
Index: src/uk/me/parabola/imgfmt/app/map/Map.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/map/Map.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/map/Map.java	(working copy)
@@ -258,7 +258,7 @@
 	 * @param flags The POI flags.
 	 */
 	public void addPoiDisplayFlags(int flags) {
-		treFile.addPoiDisplayFlags((byte) flags);
+		treFile.addPoiDisplayFlags(flags);
 	}
 
 	public void addMapObject(MapObject item) {
Index: src/uk/me/parabola/imgfmt/app/mdr/MDRHeader.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/MDRHeader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/MDRHeader.java	(working copy)
@@ -57,10 +57,10 @@
 	 * Write out the application header.
 	 */
 	protected void writeFileHeader(ImgFileWriter writer) {
-		writer.putChar((char) sort.getCodepage());
-		writer.putChar((char) sort.getId1());
-		writer.putChar((char) sort.getId2());
-		writer.putChar((char) 14);
+		writer.put2u(sort.getCodepage());
+		writer.put2u(sort.getId1());
+		writer.put2u(sort.getId2());
+		writer.put2u(14);
 
 		sections[1].writeSectionInfo(writer, true, true);
 		sections[2].writeSectionInfo(writer, true, true);
@@ -77,7 +77,7 @@
 		sections[13].writeSectionInfo(writer, true, true);
 		sections[14].writeSectionInfo(writer, true, true);
 		sections[15].writeSectionInfo(writer);
-		writer.put((byte) 0);
+		writer.put1u(0);
 
 		sections[16].writeSectionInfo(writer, true, true);
 		sections[17].writeSectionInfo(writer, false, true);
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr1.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr1.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr1.java	(working copy)
@@ -85,9 +85,9 @@
 	public void writeSectData(ImgFileWriter writer) {
 		boolean revIndex = (getExtraValue() & 1) != 0;
 		for (Mdr1Record rec : maps) {
-			writer.putInt(rec.getMapNumber());
+			writer.put4(rec.getMapNumber());
 			if (revIndex)
-				writer.putInt(rec.getIndexOffset());
+				writer.put4(rec.getIndexOffset());
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr10.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr10.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr10.java	(working copy)
@@ -80,7 +80,7 @@
 				Mdr11Record mdr11ref = t.getMdr11ref();
 				addIndexPointer(mdr11ref.getMapIndex(), count);
 				
-				writer.put((byte) t.getSubtype());
+				writer.put1u(t.getSubtype());
 				int offset = mdr11ref.getRecordNumber();
 
 				// Top bit actually represents a non-repeated name.  ie if
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr11.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr11.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr11.java	(working copy)
@@ -82,9 +82,9 @@
 			poi.setRecordNumber(count++);
 
 			putMapIndex(writer, poi.getMapIndex());
-			writer.put((byte) poi.getPointIndex());
-			writer.putChar((char) poi.getSubdiv());
-			writer.put3(poi.getLblOffset());
+			writer.put1u(poi.getPointIndex());
+			writer.put2u(poi.getSubdiv());
+			writer.put3u(poi.getLblOffset());
 			if (poi.isCity())
 				putRegionIndex(writer, poi.getRegionIndex());
 			else
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr13.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr13.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr13.java	(working copy)
@@ -39,8 +39,8 @@
 
 		for (Mdr13Record region : regions) {
 			putMapIndex(writer, region.getMapIndex());
-			writer.putChar((char) region.getRegionIndex());
-			writer.putChar((char) region.getCountryIndex());
+			writer.put2u(region.getRegionIndex());
+			writer.put2u(region.getCountryIndex());
 			putStringOffset(writer, region.getStrOffset());
 		}
 	}
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr14.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr14.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr14.java	(working copy)
@@ -35,7 +35,7 @@
 		
 		for (Mdr14Record country : countries) {
 			putMapIndex(writer, country.getMapIndex());
-			writer.putChar((char) country.getCountryIndex());
+			writer.put2u(country.getCountryIndex());
 			putStringOffset(writer, country.getStrOff());
 		}
 	}
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr17.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr17.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr17.java	(working copy)
@@ -64,7 +64,7 @@
 			len <<= 1;
 			count++;
 		}
-		writer.putN(count, len);
+		writer.putNu(count, len);
 
 		// Calculate the header. This code is unlikely to survive the finding of another example!
 		// Have no idea what the real thinking behind this is.
@@ -73,7 +73,7 @@
 		header += (prefixLength + 1) * (prefixLength + 1);
 		header += (index.getItemSize() - prefixLength - 1) * 0xa;
 
-		writer.putChar((char) header);
+		writer.put2u(header);
 		index.writeSectData(writer);
 	}
 
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr18.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr18.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr18.java	(working copy)
@@ -34,8 +34,8 @@
 	public void writeSectData(ImgFileWriter writer) {
 		int poiSize = getSizes().getSize(19);
 		for (Mdr18Record pt : poiTypes) {
-			writer.putChar((char) (pt.getType() | 0x4000));
-			writer.putN(poiSize, pt.getRecord());
+			writer.put2u(pt.getType() | 0x4000);
+			writer.putNu(poiSize, pt.getRecord());
 		}
 	}
 
